

#ifndef __LINEARB_
#define	__LINEARB_

#define WINDOWS	15
#define	INSERT	1
#define DELETE	-1

#define TRUE	1
#define FALSE	0

// macro that returns a random number in [v1, v2) 
#define random(v1,v2) (((double)(v1))+(((double)(v2)-((double)(v1)))*rand()/(RAND_MAX+1.0f)))

typedef struct linearb {
	int c[WINDOWS];
} SLB_TYPE;

typedef struct linearb_type {
    long N;			// current transaction number
    SLB_TYPE **S;		// S[m][h] hash tables 
    int m, h;		// dimensions of the hash table array S 
    int *a, *b;		// a_i and b_i -> array of h random numbers 
    int P;			// the prime number used by the hashing function 
    long M;			// largest number in data stream 
} linearb_type;

extern void linearb_print(linearb_type * hc, int id);
extern linearb_type *linearb_init(double rho, double epsilon, long M);
extern void linearb_update(linearb_type *, int, int);
extern void linearb_destroy(linearb_type *);
extern int linearb_size(linearb_type *);
extern long linearb_query(linearb_type *hc, long start, long end, long val);


#endif
