/******************************************************************************
	hCount for use with the new Tilted Time Windows
	2nd Algorithm - no intermediate windows
	01-NOV-2007
******************************************************************************/

#ifndef __SS2_
#define	__SS2_

#define HWINDOWS	20
#define	INSERT	1
#define DELETE	-1

#define TRUE	1
#define FALSE	0

// macro that returns a random number in [v1, v2) 
#define random(v1,v2) (((float)(v1))+(((float)(v2)-((float)(v1)))*rand()/(RAND_MAX+1.0f)))

typedef struct hc2 {
	int c[HWINDOWS];
} S2_TYPE;

typedef struct hc2_type {
    long N;			// current transaction number
    S2_TYPE **S;		// S[m][h] hash tables 
    int m, h;		// dimensions of the hash table array S 
    int *a, *b;		// a_i and b_i -> array of h random numbers 
    int P;			// the prime number used by the hashing function 
    long M;			// largest number in data stream 
} hc2_type;

typedef struct CounterInfo {
    long startIndex;
    long endIndex;
    int started;
    int finished;
    long currentSum;
} CounterInfo;

extern void hc2_print(hc2_type * hc, int id);
extern hc2_type *hc2_init(float rho, float epsilon, long M);
extern void hc2_update(hc2_type *, int, int);
extern void hc2_destroy(hc2_type *);
extern int hc2_size(hc2_type *);
extern long hc2_query(hc2_type *hc, long start, long end, long val);
extern void shiftIncrement(int *c);
long calculateSum(int counterIndex, long counterSize, int *c, CounterInfo *info);

#endif
